package com.ruoyi.web.work.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.web.work.api.util.AppUtil;
import com.ruoyi.web.work.domain.Packages;
import com.ruoyi.web.work.domain.Project;
import com.ruoyi.web.work.domain.Relate;
import com.ruoyi.web.work.domain.vo.ProjectListVo;
import com.ruoyi.web.work.domain.vo.RelateCompanyListVo;
import com.ruoyi.web.work.mapper.ProjectMapper;
import com.ruoyi.web.work.service.IPackagesService;
import com.ruoyi.web.work.service.IProjectService;
import com.ruoyi.web.work.service.IRelateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @author lsw
 * @date 2024-04-15
 */
@Service
public class ProjectServiceImpl extends ServiceImpl<ProjectMapper, Project> implements IProjectService {
    @Autowired
    private ProjectMapper projectMapper;

    @Autowired
    private IRelateService relateService;

    @Autowired
    private IPackagesService packagesService;

    @Override
    public List<Project> selectList(Project project) {
        return projectMapper.selectList(project);
    }

    @Override
    public List<ProjectListVo> selectProjectList(Project project) {
        List<RelateCompanyListVo> list = relateService.selectRelateCompanyList(new Relate().setUserId(AppUtil.getUser().getId()));
        List<Packages> packagesList = packagesService.selectList(new Packages().setUserId(AppUtil.getUser().getId()));
        project.setCompanyIds(list.stream().map(RelateCompanyListVo::getCompanyId).collect(Collectors.toList()));
        project.setProjectIds(packagesList.stream().map(Packages::getProjectId).collect(Collectors.toList()));
        return projectMapper.selectProjectList(project);
    }
}
